/*******************************************************************************
 * Copyright (c) 2021, Bayerische Motoren Werke Aktiengesellschaft (BMW AG)
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *******************************************************************************/

#pragma once

#include <openScenarioLib/generated/v1_1/api/ApiClassInterfacesV1_1.h>

#include <set>

namespace OPENSCENARIO
{
static inline bool IsDrivingFunctionControlledEntity(const std::string& entity_name)
{
    static std::set<std::string> viable_names = {"Ego", "Host"};

    return viable_names.count(entity_name) != 0;
}

}  // namespace OPENSCENARIO
